# colossus

Self-hosted database for organizing PC hardware benchmarking results.

## Project Goals

The goals of this project are to:

* Record benchmarking results from multiple devices - e.g. log from a laptop or a phone.
* Group results into tests - it's good practice to run a benchmark multiple times for accuracy.
* Create comparisons of hardware tests to compare performance.
* Generate graphs of hardware comparisons for usage in videos and articles.

## Development

The recommended way to run the development server for Colossus is using [Docker](https://docker.com/).

There are some shell and batch scripts in `bin/` to build and run the containers. To build the containers:

`bin/docker-build.sh` or `bin/docker-build.bat`

And then to run the containers:

`bin/docker-run.sh` or `bin/docker-run.bat`

This will build the containers for Apache and Grunt to serve the web pages and build front-end assets, respectively. If everything is running successfully you can open your browser and go to https://localhost:8080.
