<?php

use Slim\Routing\RouteCollectorProxy;

$app->get('/', '\\BitGoblin\\Colossus\\Controllers\\HomeController:getIndex')->setName('dashboard');

$app->group('/benchmark', function(RouteCollectorProxy $group) {
  $group->get('', '\\BitGoblin\\Colossus\\Controllers\\BenchmarkController:getIndex')->setName('benchmark.index');
  $group->get('/list', '\\BitGoblin\\Colossus\\Controllers\\BenchmarkController:getList')->setName('benchmark.list');
  $group->get('/add', '\\BitGoblin\\Colossus\\Controllers\\BenchmarkController:getAdd')->setName('benchmark.add');
  $group->post('/add', '\\BitGoblin\\Colossus\\Controllers\\BenchmarkController:postAdd');

  $group->group('/{benchmark_id}', function(RouteCollectorProxy $benchmark) {
    $benchmark->get('', '\\BitGoblin\\Colossus\\Controllers\\BenchmarkController:getView')->setName('benchmark.view');

    $benchmark->get('/edit', '\\BitGoblin\\Colossus\\Controllers\\BenchmarkController:getEdit')->setName('benchmark.edit');
    $benchmark->post('/edit', '\\BitGoblin\\Colossus\\Controllers\\BenchmarkController:postEdit');
  });
});

$app->group('/component', function(RouteCollectorProxy $group) {
  $group->get('', '\\BitGoblin\\Colossus\\Controllers\\ComponentController:getIndex')->setName('component.index');
  $group->get('/list', '\\BitGoblin\\Colossus\\Controllers\\ComponentController:getList')->setName('component.list');
  $group->get('/add', '\\BitGoblin\\Colossus\\Controllers\\ComponentController:getAdd')->setName('component.add');
  $group->post('/add', '\\BitGoblin\\Colossus\\Controllers\\ComponentController:postAdd');

  $group->group('/{component_id}', function(RouteCollectorProxy $component) {
    $component->get('', '\\BitGoblin\\Colossus\\Controllers\\ComponentController:getView')->setName('component.view');

    $component->get('/edit', '\\BitGoblin\\Colossus\\Controllers\\ComponentController:getEdit')->setName('component.edit');
    $component->post('/edit', '\\BitGoblin\\Colossus\\Controllers\\ComponentController:postEdit');
  });
});

$app->group('/test', function(RouteCollectorProxy $group) {
  $group->get('', '\\BitGoblin\\Colossus\\Controllers\\TestController:getList')->setName('test.list');
  $group->get('/add', '\\BitGoblin\\Colossus\\Controllers\\TestController:getAdd')->setName('test.add');
  $group->post('/add', '\\BitGoblin\\Colossus\\Controllers\\TestController:postAdd');
  $group->get('/{test_id}', '\\BitGoblin\\Colossus\\Controllers\\TestController:getView')->setName('test.view');
});

$app->group('/reports', function(RouteCollectorProxy $group) {
  $group->get('/generate', '\\BitGoblin\\Colossus\Controllers\ReportController:getGenerate')->setName('reports.generate');
});

$app->group('/api', function(RouteCollectorProxy $group) {
  $group->group('/v1', function(RouteCollectorProxy $apiv1) {
    $apiv1->get('/benchmark/details', '\\BitGoblin\\Colossus\\Controllers\\ApiController:getBenchmarkDetails')->setName('api.benchmarkDetails');
    $apiv1->get('/benchmark/tests', '\\BitGoblin\\Colossus\\Controllers\\ApiController:getBenchmarkTests')->setName('api.benchmarkTests');

    $apiv1->get('/result/list', '\\BitGoblin\\Colossus\\Controllers\\ApiController:getResultList')->setName('api.resultList');
    $apiv1->post('/result/add', '\\BitGoblin\\Colossus\\Controllers\\ApiController:postResultAdd')->setName('api.resultAdd');

    $apiv1->get('/test/details', '\\BitGoblin\\Colossus\\Controllers\\ApiController:getTestDetails')->setName('api.testDetails');
  });
});
